from sklearn.feature_extraction.text import CountVectorizer
import joblib
import topicwizard
from sklearn.decomposition import NMF
from sklearn.pipeline import make_pipeline
import pandas as pd



# params:
path2corpus = "data/bow_short_diag/bow_short_diag.df.pkl"
path2corpus = "data/bow_diag_clustering/bow_diag.df.pkl"

if __name__ == '__main__':
    vectorizer = CountVectorizer(min_df=5, max_df=0.8)

    model = NMF(n_components=10)

    topic_pipeline = make_pipeline(vectorizer, model)

    corpus_df = pd.read_pickle(path2corpus)
    corpus_dict = {case_id: corpus_df.loc[corpus_df['case_id'] == case_id, 'preprocessed_text'].values[0] for case_id in
                   corpus_df['case_id']}
    corpus = [' '.join(report) for report in corpus_df['preprocessed_text'].tolist()]

    topic_pipeline.fit(corpus)

    print("launching topicwizard visualizer (may take a while)...")
    topicwizard.visualize(corpus, model=topic_pipeline)

    exit(0)